import { LocationState } from 'history';
import React from 'react';
import { LinkProps as BaseLinkProps, NavLinkProps as BaseNavLinkProps } from 'react-router-dom';
declare type MatchProps<S = LocationState> = Pick<BaseNavLinkProps<S>, Exclude<keyof BaseNavLinkProps<S>, keyof BaseLinkProps<S>>>;
export declare type NavLinkProps<S = LocationState> = {
    href: string;
    /**
     * when true, clicking the link will replace the current entry in the history stack instead of adding a new one
     */
    replace?: boolean;
} & React.AnchorHTMLAttributes<HTMLAnchorElement> & MatchProps<S>;
export declare function NavLink({ href, ...rest }: NavLinkProps): JSX.Element;
export {};
