/// <reference types="react" />
import { SlotRegistry } from '@teambit/harmony';
import { RouteProps } from 'react-router-dom';
import { History, LocationListener } from 'history';
import { RouteSlot } from './slot-router';
import { Routing } from './route-context';
declare type RouteChangeSlot = SlotRegistry<LocationListener>;
export declare class ReactRouterUI {
    /**
     * route slot.
     */
    private routeSlot;
    /**
     *
     */
    private routeChangeListener;
    private routerHistory?;
    private routingMode;
    constructor(
    /**
     * route slot.
     */
    routeSlot: RouteSlot, 
    /**
     *
     */
    routeChangeListener: RouteChangeSlot);
    /**
     * render all slot routes.
     */
    renderRoutes(routes: RouteProps[]): JSX.Element;
    private unregisterListener?;
    /** (internal method) sets the routing engine for navigation methods */
    setRouter: (routerHistory: History<unknown>) => void;
    /** decides how navigation is stored and applied.
     * Url - updates the `window.location.pathname`.
     * Hash - updates `window.location.hash`.
     * InMemory - store state internally and don't update the browser.
     */
    setRoutingMode(routing: Routing): void;
    /**
     * register a new route.
     */
    register(route: RouteProps): this;
    registerListener(listener: LocationListener): void;
    /**
     * change browser location
     */
    navigateTo: (path: string, state?: Record<string, any>) => void;
    static slots: (((registerFn: () => string) => SlotRegistry<RouteProps>) | ((registerFn: () => string) => SlotRegistry<History.LocationListener<unknown>>))[];
    static runtime: import("@teambit/harmony").RuntimeDefinition;
    static provider(deps: any, config: any, [routeSlot, routeChangeSlot]: [RouteSlot, RouteChangeSlot]): Promise<ReactRouterUI>;
}
export {};
