"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_router_dom_1 = require("react-router-dom");
const slot_router_1 = require("./slot-router");
var Routing;
(function (Routing) {
    Routing[Routing["url"] = 0] = "url";
    Routing[Routing["hash"] = 1] = "hash";
    Routing[Routing["inMemory"] = 2] = "inMemory";
})(Routing = exports.Routing || (exports.Routing = {}));
function RouteContext({ rootRoutes, routeSlot, reactRouterUi, routing = Routing.url }) {
    const Router = getRouter(routing);
    return (react_1.default.createElement(Router, null,
        react_1.default.createElement(RouterGetter, { onRouter: reactRouterUi.setRouter }),
        react_1.default.createElement(slot_router_1.SlotRouter, { slot: routeSlot, rootRoutes: rootRoutes })));
}
exports.RouteContext = RouteContext;
function getRouter(type) {
    switch (type) {
        case Routing.inMemory:
            return react_router_dom_1.MemoryRouter;
        case Routing.hash:
            return react_router_dom_1.HashRouter;
        case Routing.url:
        default:
            return react_router_dom_1.BrowserRouter;
    }
}
// needs to be rendered inside of <BrowserRouter/>
function RouterGetter({ onRouter: onHistory }) {
    const history = react_router_dom_1.useHistory();
    react_1.useEffect(() => onHistory(history), [history]);
    return null;
}
//# sourceMappingURL=route-context.js.map