"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_router_dom_1 = require("react-router-dom");
const lodash_1 = require("lodash");
const extend_path_1 = require("./extend-path");
function SlotRouter({ slot, rootRoutes }) {
    const routes = lodash_1.flatten(slot.values());
    const withRoot = routes.concat(rootRoutes || []);
    return (react_1.default.createElement(react_router_dom_1.Switch, null, withRoot.map((route, idx) => (react_1.default.createElement(react_router_dom_1.Route, Object.assign({ key: idx }, route))))));
}
exports.SlotRouter = SlotRouter;
function SlotSubRouter({ slot, basePath }) {
    const routes = lodash_1.flatten(slot.values());
    const { path: contextPath } = react_router_dom_1.useRouteMatch();
    // TODO - generate key as part of the slot.
    return (react_1.default.createElement(react_router_dom_1.Switch, null, routes.map((route, idx) => (react_1.default.createElement(react_router_dom_1.Route, Object.assign({ key: idx }, route, { path: extend_path_1.extendPath(basePath || contextPath, route.path) }))))));
}
exports.SlotSubRouter = SlotSubRouter;
//# sourceMappingURL=slot-router.js.map